<template lang="pug">
.content.is-flex.is-align-items-center.is-justify-content-flex-start( v-if='client' )
	router-link.button.is-link.mr-4( :to='{ name: "Chats" }' )
		span.icon
			i.fa-solid.fa-arrow-left
	h2.is-marginless Пользователь {{ client.fullName || client.uhomuho }}
.box( v-if='client' )
	b-chat( :messages='client.chat.messages' @send-message='sendMessage' @retry-send='retrySend' :pending='pending' )
</template>

<script setup>
import BChat from "@/components/Chat.vue"

import { computed, onMounted, ref } from "vue"

import dayjs from "dayjs"
import { useClientSrore } from "@/stores/client"
import { useRoute } from "vue-router"
import { useSocket } from "@/stores/socket"

const $route = useRoute()
const cs = useClientSrore()
const io = useSocket()

const client = ref(null)
const pending = ref(false)

const tgId = computed(() => $route.params.tg_id)

const fetch = async () => {
	client.value = await cs.getClient(tgId.value)
}

const sendMessage = async message => {
	if (pending.value) return

	pending.value = true
	await cs.sendMessage(tgId.value, message)
	pending.value = false
}

const retrySend = messageId => {
	if (pending.value) return

	pending.value = true
	cs.retrySend(tgId.value, messageId)
	pending.value = false
}

onMounted(async () => {
	await fetch()

	io.on(`new_message`, async id => {
		if (id == tgId.value) await fetch()
	})
})
</script>